# Determine each armor stand's motion condition
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser] at @s run function amusement:robot/chaser/move_test

# If the armor stand is waiting for motion, grant it a cooldown
scoreboard objectives add chase_motion_cooldown dummy
scoreboard players add @e[type=minecraft:armor_stand,tag=slimyjim_chaser] chase_motion_cooldown 0
scoreboard players set @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=waiting_motion] chase_motion_cooldown 10
scoreboard players set @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=waiting_motion,tag=larger_delay] chase_motion_cooldown 25
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=waiting_motion] at @s run function amusement:robot/chaser/face_programmed_direction
tag @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=waiting_motion] add motion_allowed
tag @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=waiting_motion] remove waiting_motion

# Run cooldown script
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser,scores={chase_motion_cooldown=1..}] run scoreboard players remove @s chase_motion_cooldown 1

# According to their motion condition, run the following appropriate function
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=motion_allowed,tag=!waiting_motion,scores={chase_motion_cooldown=0}] at @s run function amusement:robot/chaser/move_allowed
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=!motion_allowed,tag=!waiting_motion] at @s run function amusement:robot/chaser/move_disallowed

# Update their motion animation variables
scoreboard players add @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=!backwards_motion,scores={move_animation=..30}] move_animation 1
scoreboard players remove @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=backwards_motion,scores={move_animation=1..}] move_animation 1

# If the entity has no AI, remove its "move" variable
scoreboard players reset @e[type=minecraft:armor_stand,tag=slimyjim_chaser,tag=no_ai,scores={move_animation=0..}] move_animation

# Apply the animation described above properly
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser] run function amusement:animate/move_animation

# Attack
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser] at @s positioned ~ ~1 ~ positioned ^ ^ ^0.2 if block ~ ~ ~ #amusement:robot_moveable if entity @p[gamemode=adventure,distance=0..2] run function amusement:robot/attack_kill
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser] at @s positioned ~ ~1 ~ positioned ^ ^ ^0.4 if block ~ ~ ~ #amusement:robot_moveable if entity @p[gamemode=adventure,distance=0..2] run function amusement:robot/attack_kill
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser] at @s positioned ~ ~1 ~ positioned ^1 ^ ^0.2 if block ~ ~ ~ #amusement:robot_moveable if entity @p[gamemode=adventure,distance=0..2] run function amusement:robot/attack_kill
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser] at @s positioned ~ ~1 ~ positioned ^-1 ^ ^0.2 if block ~ ~ ~ #amusement:robot_moveable if entity @p[gamemode=adventure,distance=0..2] run function amusement:robot/attack_kill

# Speak
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser,scores={chase_voice_cooldown=1..}] run scoreboard players remove @s chase_voice_cooldown 1
execute as @e[type=minecraft:armor_stand,tag=slimyjim_chaser,scores={chase_voice_cooldown=0}] at @s run function amusement:robot/chaser/speak