#Turn on observer if found
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet run function bridges:deactivate/observer


#Destroy despawner if not touching a valid bridge block
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet unless block ^ ^ ^ minecraft:waxed_cut_copper_slab unless block ^ ^ ^ minecraft:waxed_oxidized_cut_copper_slab run kill @s
#If touching a bridge block, schedule next move
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet if block ^ ^ ^ minecraft:waxed_cut_copper_slab run schedule function bridges:deactivate/move 3t

#Replace light blocks at level 15 with air
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet if block ~ ~ ~ minecraft:waxed_cut_copper_slab if block ~ ~1 ~ minecraft:light[level=15] run setblock ~ ~1 ~ minecraft:air

#Replace valid bridge blocks with air
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet if block ~ ~ ~ minecraft:waxed_cut_copper_slab run setblock ~ ~ ~ minecraft:air

#Check for intersection block (means another light bridge is blocking the deactivating one from continuing to the same spot)
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet if block ~ ~ ~ minecraft:waxed_oxidized_cut_copper_slab run tag @s add intersection_found
#If the current block is an intersection block, delete it like the other valid bridge blocks
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s if entity @s[tag=intersection_found] anchored feet run setblock ~ ~ ~ minecraft:air
#The deactivating bridge is pending expansion when the bridge that was blocking it is removed. Clear the pending spawner if applicable.
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s if entity @s[tag=intersection_found] if entity @e[limit=1,distance=0..2,type=armor_stand,name="lightbridge_spawner"] run kill @e[limit=1,distance=0..2,type=armor_stand,name="lightbridge_spawner"]
#Destroy the despawner if the intersection script is finished
execute as @e[type=armor_stand,name="lightbridge_despawner"] at @s if entity @s[tag=intersection_found] run kill

#Move the despawner forward
execute if entity @e[type=armor_stand,name="lightbridge_despawner"] as @e[type=armor_stand,name="lightbridge_despawner"] at @s anchored feet run tp @s ^ ^ ^1

#If there are pending activation armor stands, run the activate/move function. 
execute if entity @e[type=armor_stand,name="lightbridge_spawner"] run function bridges:activate/move