###### DEACTIVATION
# Now if touching an observer, change it
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if block ~ ~ ~ minecraft:observer[facing=south,powered=true] run setblock ~ ~ ~ minecraft:observer[facing=south,powered=false]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if block ~ ~ ~ minecraft:observer[facing=west,powered=true] run setblock ~ ~ ~ minecraft:observer[facing=west,powered=false]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if block ~ ~ ~ minecraft:observer[facing=east,powered=true] run setblock ~ ~ ~ minecraft:observer[facing=east,powered=false]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if block ~ ~ ~ minecraft:observer[facing=north,powered=true] run setblock ~ ~ ~ minecraft:observer[facing=north,powered=false]

#Destroy despawner if not touching a valid bridge block
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet unless block ^ ^ ^ minecraft:waxed_cut_copper_slab unless block ^ ^ ^ minecraft:waxed_oxidized_cut_copper_slab run kill @s
#If touching a bridge block, schedule next move
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet if block ^ ^ ^ minecraft:waxed_cut_copper_slab run schedule function mechanics:bridges/move 3t

#Replace light blocks at level 15 with air
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet if block ~ ~ ~ minecraft:waxed_cut_copper_slab if block ~ ~1 ~ minecraft:light[level=15] run setblock ~ ~1 ~ minecraft:air

#Replace valid bridge blocks with air
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet if block ~ ~ ~ minecraft:waxed_cut_copper_slab run setblock ~ ~ ~ minecraft:air

#Check for intersection block (means another light bridge is blocking the deactivating one from continuing to the same spot)
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet if block ~ ~ ~ minecraft:waxed_oxidized_cut_copper_slab run tag @s add intersection_found
#If the current block is an intersection block, delete it like the other valid bridge blocks
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if entity @s[tag=intersection_found] anchored feet run setblock ~ ~ ~ minecraft:air
#The deactivating bridge is pending expansion when the bridge that was blocking it is removed. Clear the pending spawner if applicable.
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if entity @s[tag=intersection_found] if entity @e[limit=1,distance=0..2,type=marker,tag=pending_lightbridge,tag=lightbridge_activate] run kill @e[limit=1,distance=0..2,type=marker,tag=pending_lightbridge,tag=lightbridge_activate]
#Destroy the despawner if the intersection script is finished
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s if entity @s[tag=intersection_found] run kill

# Particle
execute if entity @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet positioned ~ ~0.6 ~ run particle minecraft:end_rod ^ ^ ^0 0.25 0.05 0.25 0 10

#Move the despawner forward
execute if entity @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_deactivate] at @s anchored feet run tp @s ^ ^ ^1


###### ACTIVATION
#Turn on observer if found
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s if block ~ ~ ~ minecraft:observer[facing=south,powered=false] run setblock ~ ~ ~ minecraft:observer[facing=south,powered=true]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s if block ~ ~ ~ minecraft:observer[facing=west,powered=false] run setblock ~ ~ ~ minecraft:observer[facing=west,powered=true]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s if block ~ ~ ~ minecraft:observer[facing=east,powered=false] run setblock ~ ~ ~ minecraft:observer[facing=east,powered=true]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s if block ~ ~ ~ minecraft:observer[facing=north,powered=false] run setblock ~ ~ ~ minecraft:observer[facing=north,powered=true]

#If the bridge runs into another light bridge, create an intersection block instead of ending the bridge
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ~ ~ ~ minecraft:waxed_cut_copper_slab run setblock ^ ^ ^-1 minecraft:waxed_oxidized_cut_copper_slab

#If the marker was previously pending and is in front of an intersection block, clear it.
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ~ ~ ~ minecraft:air if block ^ ^ ^-1 waxed_oxidized_cut_copper_slab run setblock ^ ^ ^-1 minecraft:waxed_cut_copper_slab

#Destroy the light bridge spawner if it isn't touching a valid bridge block
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet unless block ^ ^ ^ minecraft:air unless block ^ ^ ^ minecraft:light unless block ^ ^ ^-1 minecraft:waxed_oxidized_cut_copper_slab run kill @s
#Schedule the next block placing if it is touching an empty spot and is not waiting in front of an intersection block
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ^ ^ ^ minecraft:air unless block ^ ^ ^-1 minecraft:waxed_oxidized_cut_copper_slab run schedule function mechanics:bridges/move 3t
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ^ ^ ^ minecraft:light unless block ^ ^ ^-1 minecraft:waxed_oxidized_cut_copper_slab run schedule function mechanics:bridges/move 3t

#Create a light block above the platform if applicable
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ~ ~ ~ minecraft:air if block ~ ~1 ~ minecraft:air run setblock ~ ~1 ~ minecraft:light[level=15]
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ~ ~ ~ minecraft:light if block ~ ~1 ~ minecraft:air run setblock ~ ~1 ~ minecraft:light[level=15]

#Place a bridge block if all above checks have passed
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ~ ~ ~ minecraft:air run setblock ~ ~ ~ minecraft:waxed_cut_copper_slab
execute as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet if block ~ ~ ~ minecraft:light run setblock ~ ~ ~ minecraft:waxed_cut_copper_slab

# Particle
execute if entity @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet unless block ~ ~ ~ minecraft:waxed_oxidized_cut_copper_slab positioned ~ ~0.6 ~ run particle minecraft:end_rod ^ ^ ^0 0.25 0.05 0.25 0 10

#Move the marker forward if it's not sitting in front of an intersection block
execute if entity @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] as @e[type=marker,tag=pending_lightbridge,tag=lightbridge_activate] at @s anchored feet unless block ^ ^ ^-1 minecraft:waxed_oxidized_cut_copper_slab run tp @s ^ ^ ^1